/* Klitar v 1.0 concateneur/deconcateneur
   par kli (07/97)   */

#include<iostream.h>
#include<fstream.h>   // fichiers
#include<dir.h>      // findfirst, findnext
#include<string.h>   // strcpy,strlen,strcmp
#include<stdlib.h>   // exit,atol,atoi

struct fichier {    // un fichier : son nom et sa taille.
char nomfic[13];
long taillefic;
};

// ***********************
// prototypes
int gethecat(fichier *&,char[]);
int nenfeq1(fichier *,int,char[] );
int recup(fichier *&,int &,ifstream &);
int decat (fichier *,int ,ifstream &);
int concat (char[],char[]);
int deconcat (char[]);
int setinfo(int,char *[],char[],char[]);

// **********************************
void main(int nbarg, char *arg[]) {
int ok;
char nomfichier[13],masque[13]; //nom fichier input/output et liste
int choose=setinfo(nbarg,arg,nomfichier,masque);   // on recupere les args
if (choose) ok=concat(nomfichier,masque);  // en fonction de ceux-ci :
else ok=deconcat(nomfichier);  // on concatene ou on deconcatene
if (ok) cout<<"everythings looks good !";    // tout c'est bien pass
else cout<<"something wrong...";   // ou non .
}
//***********************************

// implementation ...
// ******************

int concat(char *nomfichier,char *masque) {
// concatenation. fichier sortie et masque entree
int ok;
  fichier *fichiers;
  int nbfic=gethecat(fichiers,masque);  // on recupere la liste
  ok=nenfeq1(fichiers,nbfic,nomfichier); // et on fait ce gros fichier
  return ok;
  }



int gethecat(fichier *&fichiers,char masque[]) {
   // recupere la liste des fichiers a concatener
   struct ffblk ffblk;  // structure des infos fichier
   int ok,nbfic=0,i=0;
   ok = findfirst(masque,&ffblk,0);    // d'abord on trouve le premier
   while (!ok) {
   nbfic++;
   ok = findnext(&ffblk); // puis tout les suivants que l'on compte....
   }
   //*********
   // apres on alloue la place necessaire .
   fichiers= new fichier[nbfic];
   //et puis on rempli
   ok = findfirst(masque,&ffblk,0); // le premier
   while (!ok) {
      strcpy(fichiers[i].nomfic,ffblk.ff_name);  // le nom ou k'il faut
      fichiers[i].taillefic=ffblk.ff_fsize;  // la taille a sa place
      ok = findnext(&ffblk);  // et on passe au suivant
      i++;
      }
 return nbfic;
}

int nenfeq1(fichier *fichiers,int nbfic,char nomfichier[]) {
 // n'en fait qu'1 ! , proc principale ...
 char tampon;
 ofstream sortie(nomfichier,ios::out|ios::binary);  // on ouvre le fic sortie
 if (!sortie) return 0;  // c'est bon ?
 sortie<<"ktr";   // identification klitar file
 sortie<<nbfic; // on commence pas le y mettre le nbre de fic qu'il contiendra
 sortie.put('/'); // on separe comme ca
 for (int i=0;i<nbfic;i++) {   // puis on met au debut la liste des noms
 sortie<<fichiers[i].nomfic; // des fichiers
 sortie.put('/');
 sortie<<fichiers[i].taillefic;    // avec leur taille.
 sortie.put('/');
 }
 sortie.put('\n');
 cout<<nbfic<<" files."<<endl;
 for (i=0;i<nbfic;i++) {            // puis on copie les fichiers
    ifstream entree(fichiers[i].nomfic,ios::in|ios::binary);  //  un par un
    if (!entree) return 0;
    cout<<fichiers[i].nomfic<<"/"<<fichiers[i].taillefic;
    while (sortie && entree.get(tampon))           // octet par octet
    sortie.put(tampon);
    if (!(entree.eof())) return 0;     // on etait bien a la fin ?
    entree.close();                   // ok . on ferme !
    cout<<",added."<<endl;
 }
 return sortie.good();                // puis on regarde si le gros est ok.
 }

int deconcat(char* nomfichier) {
  // deconcatenation
  fichier *fichiers;
  int nbfic,ok=0;
  ifstream entree(nomfichier,ios::in|ios::binary); // on ouvre le gros fichier
  if (!entree) {    // il est bien la ?
  cout<<"no file "<<nomfichier;
  exit(1);
  }
  ok=recup(fichiers,nbfic,entree); // on recupere la liste des noms et tailles
  decat(fichiers,nbfic,entree);  // puis on decoupe tout !
  return ok;
  }

int recup(fichier *&fichiers,int &nbfic,ifstream &entree) {
// recupere la liste des fichiers a decouper
char tampon[15],ch,ident[3];
int i;
int numfic;
if (!entree) return 0;
for (i=0;i<3;i++)                 // verification klitar file
 entree.get(ident[i]);
 ident[i]='\0';
if (strcmp(ident,"ktr")) {
   cout<<"not a Klitar file...";         // pas bon   ?
   exit(1);                                // on sort.
   }
   i=0;
   entree.get(ch);
    while (ch!='/') {     // d'abord le nombre de fichiers
	tampon[i]=ch;
	i++;
	entree.get(ch);
	}
 tampon[i]='\0';
 nbfic=atoi(tampon);   // qu'on met la dedans
 cout<<nbfic<<" files"<<endl;
 fichiers=new fichier[nbfic];   // on alloue la bonne taille
 entree.get(ch);
 i=0;
for (numfic=0;numfic<nbfic;numfic++) { // ensuite on rempli le tableau
    while (ch!='/') {
	tampon[i]=ch;
	i++;
	entree.get(ch);
	}
  tampon[i]='\0';
  strcpy(fichiers[numfic].nomfic,tampon);     // le nom
  i=0;
  entree.get(ch);
  while (ch!='/') {
	tampon[i]=ch;
	i++;
	entree.get(ch);
	}
  tampon[i]='\0';
  fichiers[numfic].taillefic=atol(tampon); // et la taille
  i=0;    		     // (atol converti un chaine en entier long)
  entree.get(ch);
  }
 return 1;
}

int decat (fichier *fichier,int nbfic,ifstream &entree) {
  // proc principale de la deconcatenation ...
  char ch;
  for (int i=0;i<nbfic;i++) {
    cout<<fichier[i].nomfic<<"/"<<fichier[i].taillefic;
    ofstream sortie(fichier[i].nomfic,ios::out|ios::binary); // on cree la
    for(long j=0;j<fichier[i].taillefic;j++) {                // sortie
      entree.get(ch);          // on lis dans le gros
      sortie.put(ch);          // on ecris dans le petit
      }                        // taillefic fois
    cout<<",ok."<<endl;
    sortie.close();
    }                          // et on recommence nbfic fois.
  return 1;
 }

 int setinfo(int nbarg,char *arg[],char nomfichier[],char masque[]) {
 // recupere les arguments du main pour set les variables
 if (nbarg==3) {       // 3 args ?
    if (arg[1][0]=='c' || arg[1][0]=='e') {  // ok si le premier est c ou e
       strcpy(nomfichier,arg[2]);   // on a donc le nom du fichier (in ou out)
       strcpy(masque,"*.*");  // et la liste a mettre dedans (pour in)
       }}
    else if (nbarg==4 && arg[1][0]=='c') {  // ici on en a 4 (juste pour in)
	    strcpy(nomfichier,arg[2]);  // le nom du fic sortie
       strcpy(masque,arg[3]);  // et les fichiers a mettre dedans.
    }
	 else {                      // si pas bons arguments
	  cout<<"Klitar v1.0 (kli 97)"<<endl     // on explique ce qu'il fo
	      <<"help list: "<<endl		// faire !
	      <<"---------- "<<endl
	      <<"concatenation: klitar c yourfic [mask]"<<endl
	      <<"deconcatenation: klitar e yourfic"<<endl
	      <<"thanx for use !";
	      exit(1);
	 }
   return ((arg[1][0]=='c')?1:0);    // si prem arg='c' on retourne 1
 }                                   // si c'est e:0
